/*
 * Verrückte Turing-Maschinen — A turing complete game
 * Copyright (C) 2016-2018 kcf <vidofnir@folksprak.org>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */


namespace lib_trait
	{
		
		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export type type_trait<type_signature> = {[domain : string] : type_signature};


		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function create<type_signature>
			(
			)
			: type_trait<type_signature>
			{
				return {};
			}
		
		
		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function attend<type_signature>
			(
				trait : type_trait<type_signature>,
				domain : string,
				implementation : type_signature
			)
			: void
			{
				if (domain in trait)
					{
						let message : string = ("Domäne '" + domain + "' bereits vorhanden");
						throw (new Error(message));
					}
				else
					{
						trait[domain] = implementation;
					}
			}
		
		
		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function deploy<type_signature>
			(
				trait : type_trait<type_signature>,
				domain : string
			)
			: type_signature
			{
				if (! (domain in trait))
					{
						let message : string = ("keine Implementierung für Domäne '" + domain + "' vorhanden");
						throw (new Error(message));
					}
				else
					{
						return trait[domain];
					}
			}
		
	}

